# Multiplexage

## Pourquoi ?

Machines à plusieurs objectifs.

- sécurisation
- réduction de consomation
- confort de conduite

Grand nombre de périphériques à connecter.

### Conventionnalité : une connection par liaison nécessaire :

```
+---+   +---+
| A |---| B |
|   |-+ |   |
+---+ | +---+
      |   |
      | +---+
      +-| C |
        +---+
```

- Nombre de connections exponentelle.
- Difficile à mettre à jour.

### Multiplexage : une connection commune en 'réseau'.

```
+---+   +---+
| A |-+-| B |
+---+ | +---+
      |
      | +---+
      +-| C |
        +---+
```

- Nombre de connections linéaire.
- Disponibilité de l'information.

## Avantages

- moins de capteurs et de nombres de liaisons
- le poids et les couts diminuent
- extensibilité avec un cout minimal
- reconnu par une norme iso de fiabilité

## Principes

- un capteur par donnée nécessaire
- échange de donnée sur un cannal global.

### Détail

- Un réseau unifié
	- Structuration des trames
	- Synchronisation des horloges
	- Arbitrage, priorisation de l'accès au Bus

## Architecture en couches

### étage d'entrée

Interface avec les capteurs

### étage de calcul

Le microprocesseur

- contient possiblement des mémoires

### étage de sortie

Interface avec les actionneurs

## Architecture réseau

- maitre esclave
- multi-maitre
- mixte

## Protocole

- l'acheminement des trames
- synchronisation d'horloges
- deux trames peuvent être émise en même temps
	- l'arbitrage détermine celle qui est transmise
	- la seconde sera ré-émise ensuite pour ne pas perdre d'information

### Méthode CSMA

- chaque message a un ID, un ID faible donne une plus haute priorité
- un temps est réservé pour la lecture des messages à envoyer
	- un hashset des IDs supperposés est écrit sur le BUS,
	- l'ID le plus faible enverra son message au temps suivant
